<?php

namespace Drupal\custom_captcha\Controller;

use Drupal\user\UserInterface;
use Drupal\Core\Form\FormStateInterface;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\PropertyAccess\PropertyAccess;
use Drupal\Core\Controller\ControllerBase;
use Drupal\Core\Ajax\AjaxResponse;
use Drupal\Core\Ajax\CssCommand;
use Drupal\Core\Ajax\HtmlCommand;
use Drupal\Core\Form\FormBase;

/**
 * Defines HelloController class.
 */
class Custom_captcha_CaptchaCheck extends ControllerBase
{
    protected $captchaKey;

    /**
   * Constructs a new HomeController object.
   */
    public function __construct()
    {
        $this->captchaKey='no';
    }
    /**
 * {@inheritdoc}
 */
    public function validateForm(array &$form, FormStateInterface $form_state)
    {
    }
    /**
 * Ajax callback to validate the captcha field.
 */

    public function custom_captcha_validator($form, $form_state)
    {
        if ($form_state->hasValue('input_c')) {
            //($form_state->get('hidden_c'))?:$form_state->getValue('hidden_c_f');
            $captchaCheckId = $form_state->getValue('hidden_c_f');
            // Pass a key => value to other submit callbacks.
            $captchaCheck = $form_state->getValue('input_c');
            $this->captchaKey = $captchaCheckId;
            if (str_replace(' ', '', $captchaCheckId) == str_replace(' ', '', $captchaCheck)) {
                return true;
            } else {
                return false;
            }
        }
    }
    public function get_keyword()
    {
        $keywords = \Drupal::config('custom_captcha.settings')->get('keywords');
        $words = explode("\n", $keywords);
        // Keywords
        $k=array_rand($words);
        $kyeIs=$words[$k];
        $this->captchaKey=$kyeIs;
        if ($keywords == '') {
            $kyeIs = $this->incrementalHash();
        }
        return $kyeIs;
    }
    private function incrementalHash($len = 5)
    {
        $char = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
        $charLength = strlen($char);
        $random = '';
        for ($i = 0; $i < $len; $i++) {
            $random .= $char[rand(0, $charLength - 1)];
        }
        return $random;
    }
    public function custom_captcha_ajaxCallback_load(array &$form, FormStateInterface $form_state, $form_id)
    {
        // generate captcha if not there
        $kyeIs = $this->get_keyword();
        $nowWordsIs=t($kyeIs);
        // Pass multiple key => value to other submit callbacks.
        $form_state->setFormState(array(
          'hidden_c' => $nowWordsIs,
        ));
        return $form;
    }
}
